package service

import (
	"cold-delivery/app/admin/model"
	"cold-delivery/app/admin/service/dto"
	"cold-delivery/common/actions"
	cDto "cold-delivery/common/dto"
	"cold-delivery/common/global"
	"cold-delivery/common/nats/nats_server"
	"errors"
	"gogs.baozhida.cn/zoie/OAuth-core/service"
	"gorm.io/gorm"
)

type CoolerBox struct {
	service.Service
}

// GetPage 获取CoolerBox列表
func (e *CoolerBox) GetPage(c *dto.CoolerBoxGetPageReq, list *[]model.CoolerBox, count *int64, p *actions.DataPermission) error {
	var err error
	var data model.CoolerBox

	if c.PageSize == 9999 {
		err = e.Orm.Model(&data).
			Scopes(
				actions.Permission(data.TableName(), p),
			).
			Find(list).Limit(-1).Offset(-1).
			Count(count).Error
	} else {
		err = e.Orm.Model(&data).
			Scopes(
				cDto.MakeCondition(c.GetNeedSearch()),
				cDto.Paginate(c.GetPageSize(), c.GetPageIndex()),
				actions.Permission(data.TableName(), p),
			).
			Find(list).Limit(-1).Offset(-1).
			Count(count).Error
	}
	if err != nil {
		e.Log.Errorf("db error: %s", err)
		return global.GetFailedErr
	}
	if c.ShowTemp {
		// 获取公司秘钥
		var company model.SysDept
		company, err = model.GetCompanyById(p.DeptId)
		if err != nil {
			e.Log.Errorf("db error: %s", err)
			return model.GetCompanyKeyErr
		}
		for i := 0; i < len(*list); i++ {
			deviceData, _, _ := nats_server.Cold_CompanyDeviceSensor_List_ByKey((*list)[i].Sn, company.ColdKey)
			if len(deviceData) > 0 {
				(*list)[i].DeviceData = deviceData[0].T_DeviceSensorData
			}
		}
	}
	return nil
}

// Get 获取CoolerBox对象
func (e *CoolerBox) Get(d *dto.CoolerBoxGetReq, CoolerBoxModel *model.CoolerBox, p *actions.DataPermission) error {
	err := e.Orm.
		Scopes(actions.Permission(CoolerBoxModel.TableName(), p)).
		First(CoolerBoxModel, d.GetId()).Error
	if err != nil {
		e.Log.Errorf("db error: %s", err)
		if errors.Is(err, gorm.ErrRecordNotFound) {
			return global.GetNotFoundOrNoPermissionErr
		}
		return global.GetFailedErr
	}

	return nil
}

// Insert 创建CoolerBox对象
func (e *CoolerBox) Insert(c *dto.CoolerBoxInsertReq, p *actions.DataPermission) error {
	var err error
	var data model.CoolerBox

	tx := e.Orm.Begin()
	defer func() {
		if err != nil {
			tx.Rollback()
		} else {
			tx.Commit()
		}
	}()

	var k int64
	err = tx.Model(&data).Where("sn = ?", c.Sn).Count(&k).Error
	if err != nil {
		e.Log.Errorf("db error: %s", err)
		return global.CreateFailedErr
	}
	if k > 0 {
		err = errors.New("该Sn已绑定！")
		e.Log.Errorf("db error: %s", err)
		return err
	}

	var device nats_server.Device
	var company model.SysDept
	device, err = nats_server.Cold_ReadDeviceByT_sn(c.Sn)
	if err != nil {
		err = errors.New("获取SN信息失败，请检查SN是否正确！")
		e.Log.Errorf("db error: %s", err)
		return err
	}
	company, err = model.GetCompanyById(p.DeptId)
	if err != nil {
		e.Log.Errorf("db error: %s", err)
		return err
	}
	if device.T_pid != company.Id {
		err = errors.New("获取SN信息失败，请检查SN是否正确！")
		e.Log.Errorf("获取SN信息失败，device.T_pid != company.Id")
		return err
	}

	// 添加保温箱
	c.Generate(&data)
	data.HistorySn = []string{data.Sn}
	err = tx.Create(&data).Error
	if err != nil {
		e.Log.Errorf("db error: %s", err)
		return global.CreateFailedErr
	}
	c.Id = data.Id

	return nil

}
func (e *CoolerBox) BatchInsert(c *dto.CoolerBoxBatchInsertReq) error {
	var err error

	tx := e.Orm.Begin()
	defer func() {
		if err != nil {
			tx.Rollback()
		} else {
			tx.Commit()
		}
	}()

	for _, coolerBox := range c.List {
		var data model.CoolerBox

		var k int64
		err = tx.Model(&data).Where("sn = ?", coolerBox.Sn).Count(&k).Error
		if err != nil {
			e.Log.Errorf("db error: %s", err)
			return global.CreateFailedErr
		}
		if k > 0 {
			//err = errors.New("该Sn已绑定！")
			continue
		}

		// 添加保温箱
		coolerBox.CreateBy = c.CreateBy
		coolerBox.DeptId = c.DeptId
		coolerBox.Status = c.Status
		coolerBox.Generate(&data)
		data.HistorySn = []string{data.Sn}
		err = tx.Create(&data).Error
		if err != nil {
			e.Log.Errorf("db error: %s", err)
			return global.CreateFailedErr
		}
	}

	return nil

}

// Update 修改CoolerBox对象
func (e *CoolerBox) Update(c *dto.CoolerBoxUpdateReq, p *actions.DataPermission) error {
	var err error

	tx := e.Orm.Begin()
	defer func() {
		if err != nil {
			tx.Rollback()
		} else {
			tx.Commit()
		}
	}()

	var CoolerBoxModel = model.CoolerBox{}
	// 查询保温箱是否存在
	err = e.Orm.Scopes(actions.Permission(CoolerBoxModel.TableName(), p)).
		First(&CoolerBoxModel, c.GetId()).Error
	if err != nil {
		e.Log.Errorf("db error: %s", err)
		if errors.Is(err, gorm.ErrRecordNotFound) {
			return global.UpdateNotFoundOrNoPermissionErr
		}
		return global.UpdateFailedErr
	}

	if CoolerBoxModel.Sn != c.Sn {
		var k int64
		var data = model.CoolerBox{}
		err = tx.Model(&data).Where("sn = ?", c.Sn).Count(&k).Error
		if err != nil {
			e.Log.Errorf("db error: %s", err)
			return global.CreateFailedErr
		}
		if k > 0 {
			err = errors.New("该Sn已绑定！")
			e.Log.Errorf("db error: %s", err)
			return err
		}

		CoolerBoxModel.HistorySn = append(CoolerBoxModel.HistorySn, c.Sn)
	}

	c.Generate(&CoolerBoxModel)
	err = tx.Save(&CoolerBoxModel).Error
	if err != nil {
		e.Log.Errorf("db error: %s", err)
		return global.UpdateFailedErr
	}

	c.Id = CoolerBoxModel.Id
	return nil
}

// Remove 删除CoolerBox
func (e *CoolerBox) Remove(c *dto.CoolerBoxDeleteReq, p *actions.DataPermission) error {
	var err error

	tx := e.Orm.Begin()
	defer func() {
		if err != nil {
			tx.Rollback()
		} else {
			tx.Commit()
		}
	}()

	var iceRaftModel model.IceRaft
	var count int64
	err = e.Orm.Model(&iceRaftModel).
		Scopes(
			actions.Permission(iceRaftModel.TableName(), p),
			IceRaftNameRecordStatusScopes(model.IceRaftRecordStatusUsing),
			IceRaftNameRecordCoolerBoxIdScopes(c.Id),
		).
		Where("ice_raft.status = '2'").
		Joins("left join ice_raft_record on ice_raft.ice_raft_record_id = ice_raft_record.id").
		Count(&count).Error
	if err != nil {
		e.Log.Errorf("db error: %s", err)
		return global.DeleteFailedErr
	}
	if count > 0 {
		err = errors.New("该保温箱下有冰排正在使用中，无法删除！")
		return err
	}

	var CoolerBoxModel model.CoolerBox

	// 查询保温箱是否存在
	err = e.Orm.Scopes(actions.Permission(CoolerBoxModel.TableName(), p)).
		First(&CoolerBoxModel, c.GetId()).Error
	if err != nil {
		e.Log.Errorf("db error: %s", err)
		if errors.Is(err, gorm.ErrRecordNotFound) {
			return global.DeleteNotFoundOrNoPermissionErr
		}
		return global.DeleteFailedErr
	}

	db := tx.Delete(&CoolerBoxModel)

	if err = db.Error; err != nil {
		e.Log.Errorf("db error: %s", err)
		return global.DeleteFailedErr
	}
	if db.RowsAffected == 0 {
		return global.DeleteNotFoundOrNoPermissionErr
	}

	return nil
}
